using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class particleScript : MonoBehaviour
{
    public Vector3 pNow;
    Vector3 pOld;
    public float mass = 1;
    public float damp = 0.02f; 
    
    void Start()
    {
        pNow = transform.position;
        pOld = pNow;  // zero starting velocity 
    }

    // Update is called once per frame
    void FixedUpdate()
    {
        pNow = transform.position; // in order to sync with the rest of unity

        float dt = Time.fixedDeltaTime;
        Vector3 force = Vector3.down * mass *15.0f;
        Vector3 acc = force / mass;

        // Verlet:
        float k = 1 - damp * dt;
        Vector3 pNext = (1+k)*pNow - k*pOld + acc * dt * dt ;
        pOld = pNow;
        pNow = pNext;

        if (pNow.y < 0) pNow.y = 0;
        pNow.x = Mathf.Clamp(pNow.x, -10, +10);
        pNow.z = Mathf.Clamp(pNow.z, -10, +10);
        transform.position = pNow;
    }
}
